]> git.sesse.net Git - backup.sh/blob - backup.sh
More if/then consistency fixes.
[backup.sh] / backup.sh
1 #!/bin/bash
2 # backup.sh
3
4 # Backup up Unix-like computers
5
6 # itk@samfundet.no
7 #
8 # This script was first checked into RCS in 2000, and has since backed up a few
9 # servers almost every day, whenever not broken.
10
11 # It's a bit peculiar, but quite effective. The following is worth keeping in
12 # mind when hacking:
13 #
14 # Because of the way we run this script from cron, informational logging goes
15 # to stderr and warnings and errors to stdout. This way, we get mail whenever
16 # stuff fails, and other output is redirected to the log file.
17
18 # The script is halfway Norwegian and halfway English. Newer modifications are
19 # in English, we should probably stick to that.
20
21 # The computer to backup.
22 computer=$1
23
24 # Configuration
25 LOCKFILE=/home/backup/backuprun.lockfile.$computer
26 confdir=/home/backup/conf/              # Configuration files
27 storagedir=/backup                      # Where we keep backups
28 maxnumfull=3                            # Number of full backups
29 daysbetweenfull=30                      # Days between full backups
30 daysbetweenfullforfixed=32              # Days between full backups for machines with fixed
31                                         # full-backup date (in case the fixed day gets missed)
32 DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
33 DATE=`date "+%Y%m%d%H%M"`               #format: touch
34 DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
35
36 # Exclude-pattern
37 exclude=$confdir/exclude
38 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
39
40 if [ -z "$computer" ]; then
41         echo "Usage: $0 COMPUTER"
42         exit 1
43 fi
44
45 # Die more or less gracefully (at least notify user)
46 die() {
47         echo `date`": Something nasty happened."
48         rm $LOCKFILE
49         exit 1
50 }
51 diemsg() {
52         echo `date`": $computer: $@"
53         die
54 }
55
56 # Trap C-c and kill
57 trap die SIGINT SIGTERM
58
59 # Don't start if we're already running
60 if [ -e $LOCKFILE ]; then
61         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
62         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
63         exit 1
64 fi;
65 touch $LOCKFILE
66 echo $$ > $LOCKFILE
67
68 echo `date`": Backup run starting" >&2
69
70 umask 027
71
72
73 backup()
74 {
75         echo -n `date` >&2
76         printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
77
78         SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
79         incrementalsnar="/root/.backup/${sfilesystem}.snar"
80         if [ "$backuplevel" = "daglig" ]; then
81                 # If incremental backup, we need to copy the incremental status to $computer.
82                 # If it does not exist, whine a bit and then run date-based instead.
83                 if [ -s "$SNARFILE" ]; then
84                         if ! scp $SNARFILE root@$computer:$incrementalsnar; then
85                                 diemsg "Could not copy .incremental.snar to $computer"
86                         fi
87                         lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
88                 else
89                         echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
90                         incrementalsnar=""
91                         lastd=`cat ../.date`
92                         lastcmd="--newer='$lastd'"
93                 fi
94         else
95                 lastcmd="--listed-incremental=$incrementalsnar"
96         fi
97
98         # We try to run tar on the remote computer
99         #    c create archive
100         #    C change to directory first
101         #    . where to start taring (see C)
102         #    $lastcmd only files newer than this
103         #    --one-file-system don't traverse file systems
104         #    --use-compress-program compress it using gzip or pigz
105         #    --exclude-from file to get exclusion pattern from
106         #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
107         #    file and build a file list, respectivly.  
108         TARFILE=$DATE.tmp
109         TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
110                 --exclude-from=/root/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
111         echo `date`" $computer: Running $TARCMD" >&2
112         eval $TARCMD > $DATE.idx
113
114         if [ $? -eq 0 ] && [ -s $TARFILE ]; then
115                 # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
116  
117                 if [ "$incrementalsnar" ]; then
118                         if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
119                                 diemsg "Could not copy .incremental.snar from $computer"
120                         fi
121                 fi
122
123                 # Move tar file in place
124                 mv $TARFILE $DATE.tgz
125                 if [ "$incrementalsnar" ]; then
126                         mv $SNARFILE.tmp $SNARFILE
127                 fi
128
129                 # Update timestamp
130                 echo $DATEs > ../.date && touch -t $DATE ../.date
131
132                 # Make a sorted file list as well
133                 sort -k6 < $DATE.idx > $DATE.sdx
134
135                 # Fix permissions
136                 chmod 600 *tgz                      #only for us
137                 chmod 644 *sdx *idx 2>/dev/null     #everyone can read
138
139                 # Let the remote computer know that we ran a successful backup (for nagios)
140                 ssh root@$computer touch $filesystem/.lastbackup
141         else
142                 # Something wrong happened.
143                 rm $TARFILE
144                 diemsg "tar failed or $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
145         fi
146 }
147
148 # Check that the target filesystem is mounted (actually check that it's not
149 # the root filesystem)
150 if [ ! -d "$storagedir/$computer" ]; then
151         diemsg "Target filesystem ($storagedir/$computer) does not exist. Aborting"
152 fi
153 rootfilesystem=`df -P /`
154 targetfilesystem=`df -P "$storagedir/$computer"`
155 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
156         diemsg "Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
157 fi
158
159 echo `date`" $computer: Backing up $computer" >&2
160
161 # Try to SSH to the computer without entering a password.
162 if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
163         diemsg "Could not use passwordless SSH."
164 fi
165
166 # Check if pigz is available
167 if ssh -n root@$computer "pigz -V 2>/dev/null"; then
168         compressor=pigz
169 else
170         echo `date`" $computer: pigz missing; falling back to gzip."
171         compressor=gzip
172 fi
173
174 # Check dump bit in fstab
175 filesystems=`ssh -n root@$computer "cat /etc/fstab" \
176         | grep -v nfs \
177         | grep -v "^#" \
178         | grep -v "^$" \
179         | awk '{ if ( $(NF-1) != "0" ) print $2}' `
180
181 # Clean up our dir at this client
182 if ! ssh root@$computer "rm -r /root/.backup ; mkdir -m 700 /root/.backup"; then
183         diemsg "Could not create backup staging area at $computer:/root/.backup"
184 fi
185
186 # Try to copy $exclude to $computer
187 if ! scp $exclude root@$computer:/root/.backup/exclude > /dev/null; then
188         diemsg "Could not copy exclude.txt to $computer"
189 fi
190
191 # Try to copy preeexec and postexec if they exist
192 if [ -f $confdir/preexec.$computer ]; then
193         if ! scp $confdir/preexec.$computer  root@$computer:/root/.backup/preexec >&2; then
194                 diemsg "Could not copy preexec.$computer to $computer:/root/.backup/preexec"
195         fi
196 fi
197 if [ -f $confdir/postexec.$computer ]; then
198         if ! scp $confdir/postexec.$computer root@$computer:/root/.backup/postexec >&2; then
199                 diemsg "Could not copy postexec.$computer to $computer:/root/.backup/postexec"
200         fi
201 fi
202
203 # Try to run preexec if it exists
204 if ! ssh root@$computer "[ ! -f /root/.backup/preexec ] || /bin/bash -x /root/.backup/preexec" >&2; then
205         diemsg "Could not run $computer:/root/.backup/preexec"
206 fi
207
208 for filesystem in $filesystems; do
209         # Remove / and $ (for Windows) for path names
210         sfilesystem=`echo $filesystem | tr '\/\$' '__'`
211
212         # Prepare storage area
213         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
214         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
215
216         # Default backuplevel
217         backuplevel=daglig
218
219         if [ ! -s $storagedir/$computer/$sfilesystem/.date ]; then
220                 # Take the first full backup of this filesystem on this computer
221                 backuplevel=full
222         fi
223
224         # Check if we want a full backup
225         if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
226                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
227                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
228                         backuplevel=full
229                 fi
230         elif [ -f $confdir/fastfullbackupdag.$computer ]; then
231                 fullbackup_min_for_this_machine=$daysbetweenfullforfixed
232                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
233                         backuplevel=full
234                 fi
235         else
236                 fullbackup_min_for_this_machine=$daysbetweenfull 
237         fi
238
239         if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
240                 backuplevel=full
241         fi
242
243         # We want to be here
244         cd $storagedir/$computer/$sfilesystem/$backuplevel || diemsg "$storagedir/$computer/$sfilesystem/$backuplevel does not exist"
245
246         # Perform the actual backup
247         backup
248
249         # Check if this box has a custom number of full backups
250         if [ -f $confdir/maksfulle.$computer.$sfilesystem ]; then
251                 mf=$((`cat $confdir/maksfulle.$computer`+1))
252         elif [ -f $confdir/maksfulle.$computer ] ; then
253                 mf=$((`cat $confdir/maksfulle.$computer`+1))
254         else
255                 mf=$(($maxnumfull+1))
256         fi
257
258         # Delete old full backups
259         for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`; do
260                 prefix=`echo $full | sed "s/\.[^.]*$//"`
261                 echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
262                 rm $prefix*
263         done
264
265         # Delete incremental backups older than the oldest full backup
266         oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
267         find \
268                 $storagedir/$computer/$sfilesystem/daglig \
269                 -type f \
270                 \! -newer $oldf \
271                 -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
272                 -exec rm {} \; >&2
273 done
274
275 # Try to run postexec if it exist
276 if ! ssh root@$computer "[ ! -f /root/.backup/postexec ] || /bin/bash -x /root/.backup/postexec" >&2; then
277         diemsg "Could not run $computer:/root/.backup/postexec"
278 fi
279         
280 echo `date`": $computer: Backup completed successfully."
281 echo `date`": $computer: Backup completed successfully." >&2
282
283 # Remove lockfile
284 rm $LOCKFILE